//This is some code I quickly put together to test 2114 4096bit Static Ram chips.
//It is in need of a tidy up but is here in case it offers some value to others
//Prints activity to Serial
// Loop writes a value to every location then reads and compares every location
// Next time thru it increments the value, writes and then reads and repeats.
// Author Justin Richards
// Date  2015

#include<avr/io.h>

#define GIE 7//Global Int Enable
#define BCS 6// 
#define HCF 5//Half Carry Flag
#define SB 4//Sign Bit
#define TC 3 //Twos Complement
#define NF 2 //Negative Flag
#define ZF 1 //Zero Flag
#define CF 0 //Carry Flag

#define Cont 47 //PL2
#define RW 48 //PL1 WE
#define CS 49 //PL0

#define Read digitalWrite(RW, HIGH);//bitSet(PORTB,1)
#define ReadData DDRA=0x00 ; // Port A Input
#define Write digitalWrite(RW, LOW);//bitClear(PORTB,1)
#define WriteData DDRA=0xFF ; // Port A Output

#define DeSelect digitalWrite(CS, HIGH);//bitSet(PORTB,0)
#define Select digitalWrite(CS, LOW);//bitClear(PORTB,0)

//For Mega 2560 -> 2114
//   2114         Mega           Mega        2114
//  Pin  Fun   Pin    Fun     Fun   Pin   Fun    Pin
//   1 -> A6 -> 31 -> PC6 ||  5V  -> 5V -> Vcc -> 18 
//   2 -> A5 -> 32 -> PC5 ||  PC7 -> 30 -> A7  -> 17
//   3 -> A4 -> 33 -> PC4 ||  PG0 -> 41 -> A8  -> 16
//   4 -> A3 -> 34 -> PC3 ||  PG1 -> 40 -> A9  -> 15
//   5 -> A0 -> 37 -> PC0 ||  PA0 -> 22 -> D1  -> 14
//   6 -> A1 -> 36 -> PC1 ||  PA1 -> 23 -> D2  -> 13
//   7 -> A2 -> 35 -> PC2 ||  PA2 -> 24 -> D3  -> 12
//   8 -> CS -> 49 -> PL0 ||  PA3 -> 25 -> D4  -> 11
//   9 -> GND-> GND-> GND ||  PL1 -> 48 -> WE  -> 10
void setup() {

  // put your setup code here, to run once:
  DDRA=0x00; // Port A Input
  DDRC=0xFF; // Port C output
  DDRG=0xFF;
  DDRL=0xFF;

  PORTC = 0;
  PORTG = 0;
 pinMode(RW, OUTPUT);
 pinMode(CS, OUTPUT);
 pinMode(Cont,INPUT);
 DeSelect;
 Read;

   Serial.begin(115200);
 Serial.print("\n\nPortA Data:");
 Serial.print(PORTA,BIN);  //Data



  Serial.print("\n\nPortC Addr 0-7:");
  Serial.print(PORTC,BIN);  //Addr 0-7

  Serial.print("\n\nPortG Addr 8-9:");
  Serial.print(PORTG,BIN);  //Addr 8-9

  Serial.print("\n\nPortB CS & R/W:");
  Serial.print(PORTB,BIN);  //CS & R/W  

  }

void loop() {

  static uint8_t i=0;
  static int addr;
  static int Errors = 0;
  static int TotalScans = 0;
   Serial.print("\n\rTotal Scans:");Serial.print(TotalScans);Serial.print("\n\r");
  
  Serial.print("\n\rTotal Errors:");Serial.print(Errors);Serial.print("\n\r");
  
  Serial.print("\n\rNew test with Value:");Serial.print(i);Serial.print("\n\r");
  DeSelect;  
 
 // Serial.print("\r\nWriting Address location:\r\n");
  for(addr=0;addr<1024;addr++)
  {

      //Serial.print(addr);Serial.print("\r");//Serial.print(addr,BIN);



    DeSelect; 
    delay(1);
 
    PORTC = uint8_t(addr);
    bitClear(PORTG,0);
    bitClear(PORTG,1);
    if(bitRead(addr,8)==1)
    {
      bitSet(PORTG,0);
    }
    if(bitRead(addr,9)==1)
    {
      bitSet(PORTG,1);
    }
    
    PORTA = i;

    Write; //Set RW RG2 to low
    WriteData;
    delay(1);
    Select;
 
  //  delay(1);
  //  DeSelect;    

  }

Serial.print("\r\n\r\nNow reading:");

  for(addr=0;addr<1024;addr++)
  {
//    Serial.print("\n\nTesting Address location:");
//    Serial.print(addr);Serial.print(":");Serial.print(addr,BIN);
    //Serial.print(".");

    DeSelect; 
    delay(1);
 
    PORTC = uint8_t(addr);
    bitClear(PORTG,0);
    bitClear(PORTG,1);
    if(bitRead(addr,8)==1)
    {
      bitSet(PORTG,0);
    }
    if(bitRead(addr,9)==1)
    {
      bitSet(PORTG,1);
    }

    delay(1);
    Read;
    ReadData;
    delay(1);
    Select;
    delay(1);

   if((0x0F & PINA) != i)
   {
      Serial.print("\n\rError:Addr");
      Serial.print(addr);
      Serial.print("\n\rRead:");
      Serial.println(PINA,BIN);
      Serial.print("Wrote");
      Serial.println(i,BIN);
      Errors++;
   }
 
 //   DeSelect; 

  }
    i++;  
    if(i==16)
    {
      i=0; 
      TotalScans++;
    }

}
